#!/usr/bin/perl

use strict;
use warnings;

BEGIN {
    if ($0 =~ m|^(.*)/[^/]+$|) {
        push(@INC, $1);
    }
}

use SOAP::Lite +trace => 'debug';
use MIME::Base64;
use HPSMSOAP;

my $site = 'http://bp4smdemo.hpsweducation.com:13080/SM/7';
my $user = 'falcon';
my $password = 'orange perfection';
my $auth = encode_base64("$user:$password", '');

my %ticket = (
    'int' => 'Interaction',
    'inc' => 'Incident',
    'ch' => 'Change'
    );
my %wsdl = (
    'int' => 'ServiceDesk',
    'inc' => 'IncidentManagement',
    'ch' => 'ChangeManagement'
    );
my %keyname = (
    'int' => 'CallID',
    'inc' => 'IncidentID',
    'ch' => 'ChangeID'
    );

my $kind;
if ($ARGV[0] =~ m/^SD\d+$/) {
    $kind = 'int';
} elsif ($ARGV[0] =~ m/^IM\d+$/) {
    $kind = 'inc';
} elsif ($ARGV[0] =~ m/^C\d+$/) {
    $kind = 'ch';
} else {
    die "Usage: perl close.pl key\n\twhere key starts with SD, IM, C\n";
}

my $soap = SOAP::Lite->new(
    proxy => "$site/ws",
    service => "$site/$wsdl{$kind}.wsdl",
    default_ns => $site);
$soap->transport->http_request->header('Authorization' => "Basic $auth");
$soap->on_action(sub { '"Close"'; } );

my $keys = SOAP::Data->name('keys' =>
			    \SOAP::Data->name($keyname{$kind} => $ARGV[0]));
my $instance = SOAP::Data->name('instance' => '')->type('');
my $model = SOAP::Data->name('model' => \SOAP::Data->value($keys, $instance));
my $som = $soap->call("Close$ticket{$kind}", $model);

soapfault($som);
soapstatus($som);
soapdata($som, "//Close$ticket{$kind}Response/messages", 1);
soapdata($som, "//Close$ticket{$kind}Response/model", 0);
